"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styleConst = require("@cloudflare/style-const");

var _styleContainer = require("@cloudflare/style-container");

var _elements = require("@cloudflare/elements");

var _excluded = ["id", "name", "className", "indeterminate", "checked", "value", "onChange", "disabled", "testId", "label", "invalid", "noLabel", "spacing", "unwrap", "marginRight", "size", "tabIndex"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var lightSvgs = {
  encodedCheck: "url(\"data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='0 0 16 16' %3E%3Cg %3E%3Cg fill='".concat(_styleConst.theme.colors.gray[3].replace('#', '%23'), "' %3E%3Cpath d='M0,0 L16,0 L16,16 L0,16 L0,0 Z M14,4.57911065 L12.4208893,3 L6.26344364,9.1582213 L3.57911065,6.47388831 L2,8.05222337 L6.26344364,12.315667 L14,4.57911065 Z'/%3E%3C/g%3E%3C/g%3E%3C/svg%3E\")"),
  encodedIndeterminate: "url(\"data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='0 0 16 16' %3E%3Cg %3E%3Cg fill='".concat(_styleConst.theme.colors.gray[3].replace('#', '%23'), "' %3E%3Cpath d='M0,0 L16,0 L16,16 L0,16 L0,0 Z M2,7 L2,9 L14,9 L14,7 L2,7 Z'/%3E%3C/g%3E%3C/g%3E%3C/svg%3E\")")
};
var darkSvgs = {
  encodedCheck: "url(\"data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='0 0 16 16' %3E%3Cg %3E%3Cg fill='".concat(_styleConst.theme.colors.gray[4].replace('#', '%23'), "' %3E%3Cpath d='M0,0 L16,0 L16,16 L0,16 L0,0 Z M14,4.57911065 L12.4208893,3 L6.26344364,9.1582213 L3.57911065,6.47388831 L2,8.05222337 L6.26344364,12.315667 L14,4.57911065 Z'/%3E%3C/g%3E%3C/g%3E%3C/svg%3E\")"),
  encodedIndeterminate: "url(\"data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='0 0 16 16' %3E%3Cg %3E%3Cg fill='".concat(_styleConst.theme.colors.gray[4].replace('#', '%23'), "' %3E%3Cpath d='M0,0 L16,0 L16,16 L0,16 L0,0 Z M2,7 L2,9 L14,9 L14,7 L2,7 Z'/%3E%3C/g%3E%3C/g%3E%3C/svg%3E\")")
};
var CheckboxInput = (0, _styleContainer.createStyledComponent)(function (_ref) {
  var theme = _ref.theme,
      checked = _ref.checked,
      invalid = _ref.invalid,
      indeterminate = _ref.indeterminate,
      disabled = _ref.disabled,
      marginRight = _ref.marginRight,
      size = _ref.size;
  var svgs = (0, _styleConst.isDarkMode)() ? darkSvgs : lightSvgs;
  return _objectSpread(_objectSpread(_objectSpread({
    appearance: 'none',
    '-webkit-appearance': 'none',
    width: "".concat(size, "px"),
    height: "".concat(size, "px"),
    cursor: disabled ? 'default' : 'pointer',
    position: 'relative',
    overflow: 'hidden'
  }, theme.mixins.focus({
    invalid: invalid,
    border: true
  })), theme.mixins.input({
    invalid: invalid,
    radius: '5px',
    disabled: disabled
  })), {}, {
    marginRight: marginRight,
    marginLeft: 0,
    backgroundPosition: indeterminate ? '-1px' : '-1px 0',
    backgroundColor: disabled ? theme.colors.gray[8] : theme.colors.background,
    backgroundImage: indeterminate ? svgs.encodedIndeterminate : checked ? svgs.encodedCheck : 'none',
    backgroundSize: "".concat(size, "px ").concat(size, "px")
  });
}, 'input');

function Checkbox(_ref2) {
  var id = _ref2.id,
      name = _ref2.name,
      className = _ref2.className,
      _ref2$indeterminate = _ref2.indeterminate,
      indeterminate = _ref2$indeterminate === void 0 ? false : _ref2$indeterminate,
      checked = _ref2.checked,
      value = _ref2.value,
      onChange = _ref2.onChange,
      _ref2$disabled = _ref2.disabled,
      disabled = _ref2$disabled === void 0 ? false : _ref2$disabled,
      testId = _ref2.testId,
      label = _ref2.label,
      invalid = _ref2.invalid,
      noLabel = _ref2.noLabel,
      _ref2$spacing = _ref2.spacing,
      spacing = _ref2$spacing === void 0 ? 2 : _ref2$spacing,
      unwrap = _ref2.unwrap,
      _ref2$marginRight = _ref2.marginRight,
      marginRight = _ref2$marginRight === void 0 ? 3 : _ref2$marginRight,
      _ref2$size = _ref2.size,
      size = _ref2$size === void 0 ? 16 : _ref2$size,
      tabIndex = _ref2.tabIndex,
      labelProps = _objectWithoutProperties(_ref2, _excluded);

  var checkbox = /*#__PURE__*/_react.default.createElement(CheckboxInput, {
    type: "checkbox",
    name: name,
    id: id,
    checked: checked,
    disabled: disabled,
    invalid: invalid,
    onChange: onChange,
    indeterminate: indeterminate,
    className: className,
    "data-testid": testId,
    value: value,
    marginRight: marginRight,
    size: size,
    tabIndex: tabIndex
  });

  checkbox = unwrap ? checkbox : /*#__PURE__*/_react.default.createElement("div", null, checkbox);
  return noLabel || !label ? checkbox :
  /*#__PURE__*/
  // @ts-ignore
  _react.default.createElement(_elements.Label, _extends({
    display: "flex",
    alignItems: "center",
    cursor: disabled ? 'not-allowed' : 'pointer',
    opacity: disabled ? 0.5 : 1,
    m: 0,
    fontSize: "inherit",
    lineHeight: "1",
    minHeight: "auto",
    className: noLabel ? undefined : className
  }, labelProps), checkbox, label && /*#__PURE__*/_react.default.createElement(_elements.Span, {
    fontSize: 2,
    ml: spacing,
    mr: 0,
    my: 0
  }, label));
}

var _default = Checkbox;
exports.default = _default;